VERSION 5.00
Begin VB.UserControl TextScr 
   ClientHeight    =   510
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2205
   FillColor       =   &H8000000E&
   FontTransparent =   0   'False
   KeyPreview      =   -1  'True
   PaletteMode     =   0  'Halftone
   ScaleHeight     =   510
   ScaleWidth      =   2205
   ToolboxBitmap   =   "TextScr.ctx":0000
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   915
      Top             =   45
   End
   Begin VB.TextBox Te 
      Alignment       =   1  'Right Justify
      Appearance      =   0  'Flat
      BackColor       =   &H80000016&
      BorderStyle     =   0  'None
      Height          =   225
      Left            =   510
      TabIndex        =   0
      Top             =   15
      Width           =   975
   End
End
Attribute VB_Name = "TextScr"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
' ==========================================================
' Copyright  2003 Alexander Drovosekov (apexsun@narod.ru) '
' Visit apexsun.narod.ru                                   '
' ==========================================================

Event onChange(Text As String)
Dim m_Range As Long, m_Caption As String
Dim Rg As Long

Private Sub Te_Change()
    If Te.Enabled = False Then Exit Sub
    
Static oText As String

    If IsNumeric(Te.Text) = False Then Te.Text = oText
    oText = Te.Text
    RaiseEvent onChange(oText)
    Te.Text = oText
End Sub
Private Sub Te_GotFocus()
    Te.BackColor = &H80000005
    DrawRows 0, 0
End Sub
Private Sub Te_KeyPress(KeyAscii As Integer)
    If KeyAscii < Asc(0) Or KeyAscii > Asc(9) Then KeyAscii = 0
End Sub
Private Sub Te_KeyDown(KeyCode As Integer, Shift As Integer)
    If Te.Text = "" Or Not IsNumeric(Te.Text) Then Te.Text = 0
    If KeyCode = 38 Then
        Te.Text = Int(Te.Text + m_Range)
    ElseIf KeyCode = 40 Then
        Te.Text = Int(Te.Text - m_Range)
    ElseIf KeyCode = 33 Then
        Te.Text = Int(Te.Text + 10 * m_Range)
    ElseIf KeyCode = 34 Then
        Te.Text = Int(Te.Text - 10 * m_Range)
    End If
End Sub
Private Sub Te_LostFocus()
    Te.BackColor = &H80000016
    DrawRows 0, 0
End Sub
Public Property Get Text() As String
    Text = Te.Text
End Property
Public Property Let Text(ByRef vNewValue As String)
    If Te.Text <> vNewValue Then
        Te.Enabled = False
        Te.Text = vNewValue
        Te.Enabled = True
    End If
End Property
Public Property Get Caption() As String
Attribute Caption.VB_UserMemId = -518
    Caption = m_Caption
End Property
Public Property Let Caption(ByRef vNewValue As String)
    m_Caption = vNewValue
    UserControl_Resize
    DrawRows 0, 0
End Property
Public Property Get StepRange() As Long
    StepRange = m_Range
End Property
Public Property Let StepRange(ByVal vNewValue As Long)
    m_Range = vNewValue
End Property
Public Property Get AlignText() As AlignmentConstants
    AlignText = Te.Alignment
End Property
Public Property Let AlignText(ByVal vNewValue As AlignmentConstants)
    Te.Alignment = vNewValue
End Property
Private Sub Timer1_Timer()
    Te.Text = CInt(Te.Text + val(Timer1.Tag) * m_Range)
    Timer1.Interval = 200 - Rg
    DrawRows Width - IIf(val(Timer1.Tag) = 1, 260, 120), 2
    If Rg < 130 Then Rg = Rg + 3
End Sub
Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Te.Text = "" Or Not IsNumeric(Te.Text) Then Te.Text = 0
    On Error Resume Next
    Y = DrawRows(X, 2)
    Y = Switch(Y = 2, -1, Y = 1, 1, Y = 0, 0)
    Timer1.Tag = Y
    Timer1.Interval = 500
    Rg = 0
    Timer1.Enabled = True
    Te.Text = CInt(Te.Text + Y * Button * m_Range)
    Call DrawRows(X, 2)
End Sub
Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If GetCapture <> hwnd Then
        SetCapture hwnd
        DrawRows X, 1
    ElseIf X < Te.Left + Te.Width Or X > Width Or Y < 0 Or Y > Height Then
        ReleaseCapture
        DrawRows 0, 0
    Else
        DrawRows X, 1
    End If
End Sub
Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Timer1.Enabled = False
End Sub
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Caption", m_Caption, "Name")
    Call PropBag.WriteProperty("Text", Te.Text, "")
    Call PropBag.WriteProperty("Range", m_Range, 1)
    Call PropBag.WriteProperty("TextAlign", Te.Alignment, 1)
End Sub
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_Range = PropBag.ReadProperty("Range", 1)
    m_Caption = PropBag.ReadProperty("Caption", "Name")
    Te.Text = PropBag.ReadProperty("Text", 0)
    Te.Alignment = PropBag.ReadProperty("TextAlign", 1)
    UserControl_Resize
    DrawRows 0, 0
End Sub
Private Sub UserControl_Resize()
    Te.Left = TextWidth(m_Caption) + 75
    On Error Resume Next
    Te.Width = UserControl.Width - Te.Left - 330
    UserControl.Height = Te.Height + 30
    DrawRows 0, 0
End Sub
Private Function DrawRows(ByVal Xcur As Single, ByRef state As Byte) As Byte
    Dim X As Long, Y As Long, X2 As Long, Y2 As Long
    Dim cFill As Long, cText As Long
    
    AutoRedraw = True
    
    Cls
    UserControl.CurrentY = 15
    Print m_Caption
    
    X = Te.Left - 15
    Y = 0
    X2 = Width - 30
    Y2 = Te.Height + 15
    UserControl.Line (X, Y)-(X2, Y2), Te.BackColor, BF
    UserControl.Line (X, Y)-(X2, Y2), &H80000010, B
    X = X + Te.Width + 15
'    UserControl.Line (X, Y)-(X, Y2), &H80000010
    
    X = Te.Left + Te.Width + 30
    Y = 30
    X2 = Width - 60
    Y2 = Height - 45
    
    Xcur = Switch(Xcur > X + 125, 2, Xcur >= X, 1, Xcur < X, 0)
    If Xcur = 1 Then
        If state = 1 Then
            cFill = &H8000000E
            cText = &H80000012
        ElseIf state = 2 Then
            cFill = &H8000000D
            cText = &H8000000E
        End If
    Else
        cFill = &H8000000F
        cText = &H80000011
    End If
    UserControl.Line (X, Y)-(X + 120, Y2), cFill, BF
    UserControl.Line (X + 60, Y + 60)-(X + 60, Y + 75), cText
    UserControl.Line (X + 45, Y + 75)-(X + 85, Y + 75), cText
    UserControl.Line (X + 30, Y + 90)-(X + 100, Y + 90), cText
    
    If Xcur = 2 Then
        If state = 1 Then
            cFill = &H8000000E
            cText = &H80000012
        ElseIf state = 2 Then
            cFill = &H8000000D
            cText = &H8000000E
        End If
    Else
        cFill = &H8000000F
        cText = &H80000011
    End If
    UserControl.Line (X + 120, Y)-(X2, Y2), cFill, BF
    UserControl.Line (X + 180, Y2 - 60)-(X + 180, Y2 - 75), cText
    UserControl.Line (X + 165, Y2 - 75)-(X + 210, Y2 - 75), cText
    UserControl.Line (X + 150, Y2 - 90)-(X + 225, Y2 - 90), cText
    
    UserControl.Line (X, Y)-(X2, Y2), &H80000010, B
    UserControl.Line (X + 120, Y)-(X + 120, Y2), &H80000010
    AutoRedraw = False
    
    DrawRows = Xcur
End Function
